// Code generated by go-swagger; DO NOT EDIT.

package tunnel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/openziti-test-kitchen/zrok/rest_model_zrok"
)

// NewUntunnelParams creates a new UntunnelParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUntunnelParams() *UntunnelParams {
	return &UntunnelParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUntunnelParamsWithTimeout creates a new UntunnelParams object
// with the ability to set a timeout on a request.
func NewUntunnelParamsWithTimeout(timeout time.Duration) *UntunnelParams {
	return &UntunnelParams{
		timeout: timeout,
	}
}

// NewUntunnelParamsWithContext creates a new UntunnelParams object
// with the ability to set a context for a request.
func NewUntunnelParamsWithContext(ctx context.Context) *UntunnelParams {
	return &UntunnelParams{
		Context: ctx,
	}
}

// NewUntunnelParamsWithHTTPClient creates a new UntunnelParams object
// with the ability to set a custom HTTPClient for a request.
func NewUntunnelParamsWithHTTPClient(client *http.Client) *UntunnelParams {
	return &UntunnelParams{
		HTTPClient: client,
	}
}

/*
UntunnelParams contains all the parameters to send to the API endpoint

	for the untunnel operation.

	Typically these are written to a http.Request.
*/
type UntunnelParams struct {

	// Body.
	Body *rest_model_zrok.UntunnelRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the untunnel params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UntunnelParams) WithDefaults() *UntunnelParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the untunnel params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UntunnelParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the untunnel params
func (o *UntunnelParams) WithTimeout(timeout time.Duration) *UntunnelParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the untunnel params
func (o *UntunnelParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the untunnel params
func (o *UntunnelParams) WithContext(ctx context.Context) *UntunnelParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the untunnel params
func (o *UntunnelParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the untunnel params
func (o *UntunnelParams) WithHTTPClient(client *http.Client) *UntunnelParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the untunnel params
func (o *UntunnelParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the untunnel params
func (o *UntunnelParams) WithBody(body *rest_model_zrok.UntunnelRequest) *UntunnelParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the untunnel params
func (o *UntunnelParams) SetBody(body *rest_model_zrok.UntunnelRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *UntunnelParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
