// Code generated by go-swagger; DO NOT EDIT.

package tunnel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/openziti-test-kitchen/zrok/rest_model_zrok"
)

// UntunnelReader is a Reader for the Untunnel structure.
type UntunnelReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UntunnelReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUntunnelOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewUntunnelNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewUntunnelInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewUntunnelOK creates a UntunnelOK with default headers values
func NewUntunnelOK() *UntunnelOK {
	return &UntunnelOK{}
}

/*
UntunnelOK describes a response with status code 200, with default header values.

tunnel removed
*/
type UntunnelOK struct {
}

// IsSuccess returns true when this untunnel o k response has a 2xx status code
func (o *UntunnelOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this untunnel o k response has a 3xx status code
func (o *UntunnelOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this untunnel o k response has a 4xx status code
func (o *UntunnelOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this untunnel o k response has a 5xx status code
func (o *UntunnelOK) IsServerError() bool {
	return false
}

// IsCode returns true when this untunnel o k response a status code equal to that given
func (o *UntunnelOK) IsCode(code int) bool {
	return code == 200
}

func (o *UntunnelOK) Error() string {
	return fmt.Sprintf("[DELETE /untunnel][%d] untunnelOK ", 200)
}

func (o *UntunnelOK) String() string {
	return fmt.Sprintf("[DELETE /untunnel][%d] untunnelOK ", 200)
}

func (o *UntunnelOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewUntunnelNotFound creates a UntunnelNotFound with default headers values
func NewUntunnelNotFound() *UntunnelNotFound {
	return &UntunnelNotFound{}
}

/*
UntunnelNotFound describes a response with status code 404, with default header values.

not found
*/
type UntunnelNotFound struct {
	Payload rest_model_zrok.ErrorMessage
}

// IsSuccess returns true when this untunnel not found response has a 2xx status code
func (o *UntunnelNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this untunnel not found response has a 3xx status code
func (o *UntunnelNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this untunnel not found response has a 4xx status code
func (o *UntunnelNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this untunnel not found response has a 5xx status code
func (o *UntunnelNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this untunnel not found response a status code equal to that given
func (o *UntunnelNotFound) IsCode(code int) bool {
	return code == 404
}

func (o *UntunnelNotFound) Error() string {
	return fmt.Sprintf("[DELETE /untunnel][%d] untunnelNotFound  %+v", 404, o.Payload)
}

func (o *UntunnelNotFound) String() string {
	return fmt.Sprintf("[DELETE /untunnel][%d] untunnelNotFound  %+v", 404, o.Payload)
}

func (o *UntunnelNotFound) GetPayload() rest_model_zrok.ErrorMessage {
	return o.Payload
}

func (o *UntunnelNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUntunnelInternalServerError creates a UntunnelInternalServerError with default headers values
func NewUntunnelInternalServerError() *UntunnelInternalServerError {
	return &UntunnelInternalServerError{}
}

/*
UntunnelInternalServerError describes a response with status code 500, with default header values.

internal server error
*/
type UntunnelInternalServerError struct {
	Payload rest_model_zrok.ErrorMessage
}

// IsSuccess returns true when this untunnel internal server error response has a 2xx status code
func (o *UntunnelInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this untunnel internal server error response has a 3xx status code
func (o *UntunnelInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this untunnel internal server error response has a 4xx status code
func (o *UntunnelInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this untunnel internal server error response has a 5xx status code
func (o *UntunnelInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this untunnel internal server error response a status code equal to that given
func (o *UntunnelInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *UntunnelInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /untunnel][%d] untunnelInternalServerError  %+v", 500, o.Payload)
}

func (o *UntunnelInternalServerError) String() string {
	return fmt.Sprintf("[DELETE /untunnel][%d] untunnelInternalServerError  %+v", 500, o.Payload)
}

func (o *UntunnelInternalServerError) GetPayload() rest_model_zrok.ErrorMessage {
	return o.Payload
}

func (o *UntunnelInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
